import cz.zcu.fav.kiv.jsim.*;

public class CriticalProcess extends JSimProcess {
  private JSimHead queue;
  private ThreadProcess tp[];
  private double mu;
  private long count;
  private double time;
  

  public CriticalProcess(String name, JSimHead q, double mu, JSimSimulation sim) throws JSimException {
    super(name, sim);
    this.queue = q;
    this.mu = mu;
    this.count = 0;
    this.time = 0;
  }

  public void setProcesses(ThreadProcess tp[]) {
    this.tp = tp;
  }

  protected void life() {
    Transaction link;

    try {
     while (true) {
        // není co dělat, počkáme na nějaké vlákno
        if (queue.empty()) passivate();

        // máme vlákno, zpracujeme ho
        hold(JSimSystem.negExp(mu));
//        hold(mu);

		// vyndáme zpracované vlákno z fronty
        link = (Transaction)queue.first();
        link.out();
        count++;
        time += (myParent.getCurrentTime() - link.getTime());
        
        tp[((Integer)link.getData()).intValue()].activate(myParent.getCurrentTime());        
     }
    } catch (JSimException je) {
      je.printStackTrace();
      je.printComment(System.out);
    }
  }
  
  public double getTw() {
  	return time / count;
  }
}
