import cz.zcu.fav.kiv.jsim.*;

public class ThreadProcess extends JSimProcess {
  private JSimHead queue;
  private int id;
  private double lambda;
  private CriticalProcess cp;

  public ThreadProcess(int id, JSimHead q, double lambda, CriticalProcess cp, JSimSimulation sim) throws JSimException {
    super("Vlákno " + id, sim);
    this.queue = q;
    this.id = id;
    this.lambda = lambda;
    this.cp = cp;
  }

  protected void life() {
    JSimLink link;

    try {
      while(true) {
        link = new Transaction(id, myParent.getCurrentTime());
//        hold(lambda);
        hold(JSimSystem.negExp(lambda));
        link.into(queue);
        if (cp.isIdle())
          cp.activate(myParent.getCurrentTime());
        passivate();
      }
    } catch (JSimException jse) {
      jse.printStackTrace();
      jse.printComment(System.err);
    }
  }
}
