import cz.zcu.fav.kiv.jsim.*;

public class Threads {
  public final double LAMBDA = 0.5;
  public final double MU = 1.0;

  Threads() {
    JSimSimulation sim;
    ThreadProcess p[];
    CriticalProcess cp;
    JSimHead q;

    sim = new JSimSimulation("Vlákna a kritická sekce");
    p = new ThreadProcess[3];
    try {
//      sim.setTalking(true);
      q = new JSimHead("Fronta vláken", sim);
	  cp = new CriticalProcess("Kritická sekce", q, MU, sim);
      p[0] = new ThreadProcess(0, q, LAMBDA, cp, sim);
      p[1] = new ThreadProcess(1, q, LAMBDA, cp, sim);
      p[2] = new ThreadProcess(2, q, LAMBDA, cp, sim);
      cp.setProcesses(p);
      p[0].activate(0.0);
      p[1].activate(0.0);
      p[2].activate(0.0);
      cp.activate(0);
      {
      	int i = 0;
		while (sim.getCurrentTime() < 40000 && sim.step()) i++;
		System.out.println(i);
      }
      System.out.println("Cyklus vlákna dle matematického modelu: " + 3.800);
      System.out.println("Cyklus vlákna podle experimentu: " + cp.getTw());

    } catch (Exception e) {
      e.getMessage();
    } finally {
      sim.shutdown();
    }
  }

  public static void main(String[] args) {
    new Threads();
  }
}
